package cn.efunbox.audio.impl;

import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.entity.Device;
import cn.efunbox.audio.repository.AudioRepo;
import cn.efunbox.audio.repository.DeviceRepo;
import cn.efunbox.audio.service.AudioService;
import cn.efunbox.audio.service.DeviceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * Created by yao on 17-9-26.
 */
@Service
public class AudioServiceImpl implements AudioService {

    @Autowired
    AudioRepo audioRepo;

    @Override
    public Audio GetOne(Long id){
        Audio audio = audioRepo.findById(id);
        return audio;
    }

    @Override
    public List<Audio> SearchAll(){
        List<Audio> list = audioRepo.findAll();
        return list;
    }

    @Override
    public List<Audio> SearchByIdGroup(Long idGroup){
        List<Audio> list = audioRepo.findByIdGroup(idGroup);
        return list;
    }

    @Override
    public List<Audio> SearchByName(String name){
        if(name==null || name.isEmpty())
            return null;
        List<Audio> list = audioRepo.findByName(name);
//        System.out.println("list1:"+list.toString());
        if(list==null)
            list = audioRepo.findByNameLike("%"+name+"%");
//        System.out.println("list2:"+list.toString());
        return list;
    }

    @Override
    public List<Audio> SearchByAlbum(String album){
        if(album==null || album.isEmpty())
            return null;
        List<Audio> list = audioRepo.findByAlbum(album);
        if(list==null)
            list = audioRepo.findByAlbumLike(album);
        return list;
    }

    @Override
    public List<Audio> SearchByNameAlbum(String name, String album){
        if(name==null || name.isEmpty()
                || album==null || album.isEmpty())
            return null;
        List<Audio> list = audioRepo.findByNameAndAlbum(name, album);
        if(list==null)
            list = audioRepo.searchByNameAndAlbum(name, album);

        return list;
    }

    @Override
    public Audio Insert(Audio audio){
        Audio a = audioRepo.save(audio);
        return a;
    }

    @Override
    public void Delete(Long id){
        audioRepo.delete(id);
    }

}
