package cn.efunbox.audio.impl;

import cn.efunbox.audio.entity.Channel;
import cn.efunbox.audio.entity.Grouping;
import cn.efunbox.audio.repository.ChannelRepo;
import cn.efunbox.audio.repository.GroupingRepo;
import cn.efunbox.audio.service.ChannelService;
import cn.efunbox.audio.service.GroupingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Service
public class GroupingServiceImpl implements GroupingService {

    @Autowired
    GroupingRepo groupingRepo;

    @Override
    public Grouping GetOne(Long id){
        Grouping grouping = groupingRepo.findOne(id);
        return grouping;
    }

    @Override
    public List<Grouping> SearchAll(){
        List<Grouping> list = groupingRepo.findAll();
        return list;
    }

    @Override
    public List<Grouping> SearchById(Long id){
        List<Grouping> list = groupingRepo.findById(id);
        return list;
    }

    @Override
    public List<Grouping> SearchByIdFather(Long idFather){
        List<Grouping> list = groupingRepo.findByIdFather(idFather);
        return list;
    }

    @Override
    public List<Grouping> SearchByName(String name){
        if(name==null || name.isEmpty())
            return null;
        List<Grouping> list = groupingRepo.findByName(name);
        if(list==null)
            list = groupingRepo.findByNameLike(name);
        return list;
    }

    @Override
    public Grouping Insert(Grouping grouping){
        Grouping c = groupingRepo.save(grouping);
        return c;
    }

    @Override
    public void Delete(Long id){
        groupingRepo.delete(id);
    }

}
