package cn.efunbox.audio.impl;

import cn.efunbox.audio.entity.Channel;
import cn.efunbox.audio.entity.Rights;
import cn.efunbox.audio.repository.ChannelRepo;
import cn.efunbox.audio.repository.RightsRepo;
import cn.efunbox.audio.service.ChannelService;
import cn.efunbox.audio.service.RightsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Service
public class RightsServiceImpl implements RightsService {

    @Autowired
    RightsRepo rightsRepo;

    @Override
    public Rights GetOne(Long id){
        Rights rights = rightsRepo.findOne(id);
        return rights;
    }

    @Override
    public List<Rights> SearchAll(){
        List<Rights> list = rightsRepo.findAll();
        return list;
    }

    @Override
    public List<Rights> SearchById(Long id){
        List<Rights> list = rightsRepo.findById(id);
        return list;
    }

    @Override
    public List<Rights> SearchByIdChannel(Long id){
        List<Rights> list = rightsRepo.findByIdChannel(id);
        return list;
    }

    @Override
    public List<Rights> SearchByIdGroup(Long id){
        List<Rights> list = rightsRepo.findByIdGroup(id);
        return list;
    }

    @Override
    public List<Rights> SearchByIdChannelAndIdGroup(Long idChannel, Long idGroup){
        List<Rights> list = rightsRepo.findByIdChannelAndIdGroup(idChannel, idGroup);
        return list;
    }

    @Override
    public List<Rights> SearchByNameChannel(String name){
        if(name==null || name.isEmpty())
            return null;
        List<Rights> list = rightsRepo.findByNameChannel(name);
        return list;
    }

    @Override
    public List<Rights> SearchByNameGroup(String name){
        if(name==null || name.isEmpty())
            return null;
        List<Rights> list = rightsRepo.findByNameGroup(name);
        return list;
    }

    @Override
    public Rights Insert(Rights rights){
        Rights r = rightsRepo.save(rights);
        return r;
    }

    @Override
    public void Delete(Long id){
        rightsRepo.delete(id);
    }

}
