package cn.efunbox.audio.repository;

import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.entity.Device;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Repository
public interface AudioRepo extends JpaRepository<Audio, Long> {

    Audio findById(Long id);

    List<Audio> findByName(String name);

    @Query("from Audio a where a.name LIKE :name")
    List<Audio> findByNameLike(String name);

    List<Audio> findByNameContaining(String name);

    List<Audio> findByIdGroup(Long idGroup);

    List<Audio> findByAlbum( String Album);

    List<Audio> findByAlbumLike( String Album);

    List<Audio> findByNameAndAlbum(String name, String Album);

    @Query("from Audio a where a.name like CONCAT('%',:name,'%') and a.album like CONCAT('%',:album,'%') ")
    List<Audio> searchByNameAndAlbum(@Param("name") String name, @Param("album") String album);
}
