package cn.efunbox.audio.utils;

import java.lang.reflect.Method;
import java.security.MessageDigest;

/**
 * Created by yao on 17-10-12.
 */
public class Common {


    /**
     * 将同类型的两个对象的数据进行合并，objTarget中为null的数据用objSource中的元素代替
     * @param objTarget
     * @param objSource
     * @return
     */
    public static Object CopyValue(Object objTarget, Object objSource){
        for(int i=0; i<objTarget.getClass().getDeclaredFields().length; i++){
            try {
                String fieldName = objTarget.getClass().getDeclaredFields()[i].getName();
//                System.out.println(fieldName);
                String value = GetFieldValueByName(fieldName, objTarget)==null?"":GetFieldValueByName(fieldName, objTarget).toString();
//                System.out.println(fieldName+":"+value);
//                if((null==value || value.toString().equalsIgnoreCase("") || value.toString().equalsIgnoreCase("0"))
                if((null==GetFieldValueByName(fieldName, objTarget))
                        && null!=GetFieldValueByName(fieldName, objSource))
                    SetFieldValueByName(objTarget, fieldName, GetFieldValueByName(fieldName, objSource));
            }
            catch (Exception e){
                System.out.println(e.getMessage());
            }
        }

        return  objTarget;
    }

    /**
     * 根据属性名获取属性值
     * */
    public static Object GetFieldValueByName(String fieldName, Object o) {
        try {
            String firstLetter = fieldName.substring(0, 1).toUpperCase();
            String getter = "get" + firstLetter + fieldName.substring(1);
            Method method = o.getClass().getMethod(getter, new Class[] {});
            Object value = method.invoke(o, new Object[] {});
            return value;
        } catch (Exception e) {
            System.out.println(e.getMessage());
            return null;
        }
    }

    /**
     * 用反射设置对象的属性值
     * @param obj 需要設置值的對象
     * @param fieldName 需要設置值的屬性
     * @param value 需要设置的值
     * @return 设置值后的对象
     */
    public static Object SetFieldValueByName(Object obj, String fieldName, Object value) {
        try{
            String firstWord = fieldName.substring(0, 1).toUpperCase();
            String methodName = String.format("set%s%s", firstWord, fieldName.substring(1));
            Method method = obj.getClass().getMethod(methodName, value.getClass());
            method.invoke(obj, value);
        }catch (Exception e) {
            System.out.println("SetFieldValueByName error:" + e.getMessage());
            return null;
        }

        return obj;
    }


    //生成MD5
    public static String getMD5(String message) {
        String md5 = "";
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");  // 创建一个md5算法对象
            byte[] messageByte = message.getBytes("UTF-8");
            byte[] md5Byte = md.digest(messageByte);              // 获得MD5字节数组,16*8=128位
            md5 = bytesToHex(md5Byte);                            // 转换为16进制字符串
        } catch (Exception e) {
            e.printStackTrace();
        }
        return md5;
    }

    // 二进制转十六进制
    public static String bytesToHex(byte[] bytes) {
        StringBuffer hexStr = new StringBuffer();
        int num;
        for (int i = 0; i < bytes.length; i++) {
            num = bytes[i];
            if(num < 0) {
                num += 256;
            }
            if(num < 16){
                hexStr.append("0");
            }
            hexStr.append(Integer.toHexString(num));
        }
        return hexStr.toString().toUpperCase();
    }
}
